import { IsArray, IsEnum, IsNotEmpty } from 'class-validator';
import { ContextItem } from './context-item';
import { Action } from './action.enum';
import { Domain } from './domain.enum';

export class DecisionRequest {
  @IsEnum(Domain)
  @IsNotEmpty()
  domain: Domain;

  @IsEnum(Action)
  @IsNotEmpty()
  action: Action;

  @IsArray()
  context?: Array<ContextItem>;
}
