import { QueryHandler } from '@nestjs/cqrs';
import { OpaDecisionMaker } from '../../adapters/secondaries/opa.decision-maker';
import { DecisionQuery } from '../../queries/decision.query';
import { Authorization } from '../entities/authorization';

@QueryHandler(DecisionQuery)
export class DecisionUseCase {
  constructor(private readonly decisionMaker: OpaDecisionMaker) {}

  execute = (decisionQuery: DecisionQuery): Promise<Authorization> =>
    this.decisionMaker.decide(
      decisionQuery.domain,
      decisionQuery.action,
      decisionQuery.context,
    );
}
